require 'em-websocket'

# Preparar el mensaje a mostrar en los clientes.
def procesar entrada
  tiempo_actual = Time.now.strftime("%d/%m/%y %H:%m:%S")
  mensaje = entrada.split("__::::__")
  "<b>#{mensaje[0]}</b> <small>(#{tiempo_actual})</small>:<br> #{mensaje[1]}"    
end

HOST = "127.0.0.1"
PORT = 8080

puts "Iniciando el servicio..."

EM.run {
  
  @channel = EM::Channel.new
  
  EM::WebSocket.run(host: HOST, port: PORT) do |ws|
    ws.onopen do |handshake|
      puts "Conectado."
      @channel.subscribe { |msg| ws.send msg }
      @channel.push "Conectado"
    end

    ws.onmessage {|msg| @channel.push "#{procesar(msg)}" }
        
    ws.onerror { |e|  puts "Error #{e.message}" }
       
    ws.onclose { puts "Desconectado." }

  end
}